'---------------------------------------------------------
'		file I/O function
'		Copyright (c) 2019 Masamichi Kirikae
'---------------------------------------------------------

#include once "fileio.bi"

namespace libfio

function fgetbyte(byref fh as sint32) as byte
	dim dc as byte
	get #fh, , dc
	return dc
end function

function fgetubyte(byref fh as sint32) as ubyte
	dim dc as ubyte
	get #fh, , dc
	return dc
end function

function fgetint16(byref fh as sint32) as sint16
	dim di16 as sint16
	get #fh, , di16
	return di16
end function

function fgetuint16(byref fh as sint32) as uint16
	dim di16 as uint16
	get #fh, , di16
	return di16
end function

function fgetint32(byref fh as sint32) as sint32
	dim di as sint32
	get #fh, , di
	return di
end function

function fgetuint32(byref fh as sint32) as uint32
	dim di as uint32
	get #fh, , di
	return di
end function

function fgetstring(byref fh as sint32, byref n as sint32) as string
	dim i as sint32, dc as ubyte, st as string
	st = ""
	for i = 1 to n
		get #fh, , dc
		st += chr(dc)
	next
	return st
end function

function fgetstringz(byref fh as sint32) as string
	dim dc as ubyte, st as string
	st = ""
	do
		get #fh, , dc
		if dc = 0 then exit do
		st += chr(dc)
	loop while (true)
	return st
end function

function change_filename_ext(byref filename as string, byref ext as string) as string
	dim i as sint32, lg as sint32, pn as sint32, st as string
	lg = len(filename)
	pn = lg
	for i =	lg to 1 step -1
		if mid(filename, i, 1) = "." then
			pn = i
			exit for
		endif
	next
	st = mid(filename, 1, pn - 1)
	st = st + ext
	return st
end function

function get_filename_ext(byref filename as string) as string
	dim i as sint32, lg as sint32, pn as sint32, st as string
	lg = len(filename)
	for i = lg to 1 step -1
		if mid(filename, i, 1) = "." then
			pn = i
			exit for
		endif
	next
	st = mid(filename, pn+1, lg - pn)
	return st
end function

function get_directory(byref filename as string) as string
	dim i as sint32, lg as sint32, pn as sint32, st as string
	lg = len(filename)
	if lg = 0 then
		return ""	'	no directory
	endif
	pn = 0
	for i = lg to 1 step -1
		if mid(filename, i, 1) = "\" then
			pn = i
			exit for
		endif
	next
	st = mid(filename, 1, pn)
	return st
end function

function get_filename_only(byref filename as string) as string
	dim i as sint32, lg as sint32, pn as sint32, st as string
	lg = len(filename)
	if lg = 0 then
		return ""	'	no filename
	endif
	pn = 0
	for i = lg to 1 step -1
		if mid(filename, i, 1) = "\" then
			pn = i
			exit for
		endif
	next
	st = mid(filename, pn+1, lg - pn)
	return st
	
end function

end namespace
