'---------------------------------------------------------
'		file I/O function and variable type definition
'		Copyright (c) 2019 Masamichi Kirikae
'---------------------------------------------------------
#include once "file.bi"
#include once "datatype.bi"

#ifndef FUNC_NOERROR
	#define FUNC_NOERROR	0
	#define FUNC_ERROR	1
#endif

#define cprint		print #console,
common shared console as sint32	' file handle for console

#define fpseek(fh, fp) 			seek #(fh), ((fp) + 1)
#define fputbyte(fh, dc)		put #(fh), ,cbyte(dc)
#define fputubyte(fh, dc)		put #(fh), ,cubyte(dc)
#define fputint16(fh, dc)		put #(fh), ,cast(sint16, (dc))
#define fputuint16(fh, dc)		put #(fh), ,cast(uint16, (dc))
#define fputint32(fh, dc)		put #(fh), ,cast(sint32, (dc))
#define fputuint32(fh, dc)		put #(fh), ,cast(uint32, (dc))
#define fputstringz(fh, st)	put #(fh), ,st

namespace libfio

declare function fgetbyte(byref fh as sint32) as byte
declare function fgetubyte(byref fh as sint32) as ubyte
declare function fgetint16(byref fh as sint32) as sint16
declare function fgetuint16(byref fh as sint32) as uint16
declare function fgetint32(byref fh as sint32) as sint32
declare function fgetuint32(byref fh as sint32) as uint32
declare function fgetstring(byref fh as sint32, byref n as sint32) as string
declare function fgetstringz(byref fh as sint32) as string
declare function change_filename_ext(byref filename as string, byref ext as string) as string
declare function get_filename_ext(byref filename as string) as string
declare function get_directory(byref filename as string) as string
declare function get_filename_only(byref filename as string) as string

end namespace
