'-------------------------------------------------
'		Save and Load png imagefile
'		Copyright (c) 2016 Masamichi Kirikae
'-------------------------------------------------

#include once "dir.bi" 	'provides constants to use for the attrib_mask parameter
#include once "file.bi"
#include once "zlib.bi"
#include once "datatype.bi"

#ifndef console
	common shared console as sint32
#endif

#ifndef cprint
	#define cprint print #console,
#endif

#ifndef F_NOERROR
	#define F_NOERROR	0
	#define F_ERROR	1
#endif

#define PNG_NO_ERROR			0
#define PNG_ERROR_OPEN		1
#define PNG_ERROR_FORMAT	2
#define PNG_ERROR_SIZE		4
#define PNG_ERROR_COMPRESS	8
#define PNG_ERROR_ANY		128

#ifndef RGBA_MAX_SIZE
	#define RGBA_MAX_SIZE	2048 * 2048 * 4
#endif

#ifndef rgba_data
	type rgba_data
		r as ubyte
		g as ubyte
		b as ubyte
		a as ubyte
	end type
#endif

namespace libpng

type struct_ihdr field = 1
	width as uint32
	height as uint32
	bitdepth as ubyte
	colourtype as ubyte
	compression as ubyte
	filter as ubyte
	interlace as ubyte
end type

const pngheader as string = chr(&h89) & "PNG" & chr(&hd, &ha, &h1a, &ha)
const ihdrcrc as uint32 = &ha8a1ae0a 'crc32(0, @"IHDR", 4)
const pltecrc as uint32 = &h4ba88955 'crc32(0, @"PLTE", 4)
const idatcrc as uint32 = &h35af061e 'crc32(0, @"IDAT", 4)
const iendcrc as uint32 = &hae426082 'crc32(0, @"IEND", 4)
	
' shared variables
dim shared as sint32 g_width = 0, g_height = 0, g_bypp = 0, g_bitdepth = 0

declare function bswap(byval n as uint32) as uint32
declare function save_png(byref filename as string, img_rgba() as ubyte, w as uint32, h as uint32, depth as uint32) as sint32
declare sub encode_filter_none(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare sub encode_filter_sub(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare sub encode_filter_up(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare sub decode_filter_sub(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare sub decode_filter_up(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare sub decode_filter_average(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare function paethpredictor(a as ubyte, b as ubyte, c as ubyte) as ubyte
declare sub decode_filter_paeth(image_rgba as ubyte ptr, image as ubyte ptr, y as sint32)
declare function load_png(byref filename as string, image_rgba() as ubyte, byref imgw as sint32, byref imgh as sint32, byref bytepp as sint32) as sint32

end namespace
