'		sr2ctsmapper header file
'		Copyright (c) 2019 Masamichi Kirikae
'-------------------------------------------------
#include once "fbgfx.bi"
#include once "dir.bi" 	'provides constants to use for the attrib_mask parameter
#include once "file.bi"
#include once "datatype.bi"
#include once "fileio.bi"
#include once "pnglib.bi"


#define _DEBUG		0
#define F_NOERROR	0
#define F_ERROR	1

#ifndef false
	#define false	0
	#define true	(not(false))
#endif

#define BACKGROUND_GRID		0
#define BACKGROUND_WHITE	1
#define BACKGROUND_BLACK	2

#define CTS_IGNORE	0
#define CTS_NAVPOINT	1
#define CTS_TYPE		2
#define CTS_POS		4
#define CTS_ORIENT	8

#define WindowWidth	1280
#define WindowHeight	720

#define Char_Size		4
#define Cross_Size	2

#define uimapfilename	"\ui_map_world_city.tga_0.png"

#define lower(a, b, c) if a < b then c = a else c = b

#macro rgb565_to_rgba(c, r, g, b, a)
	r = ((c) and &HF800) shr 8		'&b1111 1000 0000 0000
	g = ((c) and &H07E0) shr 3		'&b0000 0111 1110 0000
	b = ((c) and &H001F) shl 3		'&b0000 0000 0001 1111
	a = &Hff
#endmacro

#macro rgb_to_rgb565(c, r, g, b)
	'rrrr rggg gggb bbbb
	c = (b) shr 3							' bbbb b000
	c = c or (((g) shr 2) shl 5)		' gggg gg00 
	c = c or (((r) shr 3) shl 11)	' rrrr r000
#endmacro

type mouse_data
	x as sint32
	y as sint32
	wheel as sint32
	lbutton as sint32
	rbutton as sint32
	mbutton as sint32
	clip as sint32
end type

#ifndef rgba_data
	type rgba_data
		r as ubyte
		g as ubyte
		b as ubyte
		a as ubyte
	end type
#endif

type navpoints
	navpoint	as string
	pos_type	as string
	pos_x		as double
	pos_y		as double
	pos_z		as double
	pos_gx		as double
	pos_gy		as double
	colour		as rgba_data
	orient		as string
end type

dim shared as ubyte ch_p(6, 6) = {_
{0, 0, 0, 1, 0, 0, 0},_
{0, 0, 0, 1, 0, 0, 0},_
{0, 0, 0, 1, 0, 0, 0},_
{1, 1, 1, 1, 1, 1, 1},_
{0, 0, 0, 1, 0, 0, 0},_
{0, 0, 0, 1, 0, 0, 0},_
{0, 0, 0, 1, 0, 0, 0}}

dim shared as ubyte ch_m(6, 6) = {_
{0, 0, 0, 0, 0, 0, 0},_
{0, 0, 0, 0, 0, 0, 0},_
{0, 0, 0, 0, 0, 0, 0},_
{1, 1, 1, 1, 1, 1, 1},_
{0, 0, 0, 0, 0, 0, 0},_
{0, 0, 0, 0, 0, 0, 0},_
{0, 0, 0, 0, 0, 0, 0}}

dim shared as ubyte ch_z(6, 6) = {_
{0, 1, 1, 1, 1, 1, 0},_
{1, 0, 0, 0, 0, 1, 1},_
{1, 0, 0, 0, 1, 0, 1},_
{1, 0, 0, 1, 0, 0, 1},_
{1, 0, 1, 0, 0, 0, 1},_
{1, 1, 0, 0, 0, 0, 0},_
{0, 1, 1, 1, 1, 1, 0}}


dim shared navpts(2000) as navpoints
dim shared navnum as sint32
dim shared graphic_width as sint32
dim shared graphic_height as sint32

declare sub zvalue_to_color(z as double, byref r as sint32, byref g as sint32, byref b as sint32)
declare function rgba_to_rgb(c as rgba_data) as rgba_data
declare sub set_rgba(c as rgba_data, r as sint32, g as sint32, b as sint32)
declare function readnavpoint(strline as string) as sint32
declare sub graphic_line(image_rgba() as ubyte, xs as sint32, ys as sint32, xe as sint32, ye as sint32, c as rgba_data)
declare sub graph_box(image_rgba() as ubyte, xs as sint32, ys as sint32, xe as sint32, ye as sint32, c as rgba_data)
declare sub drawcross(imgage_rgba() as ubyte, gx as sint32, gy as sint32,c as rgba_data)
declare sub drawmap_to_image(byref image as any ptr, image_rgba() as ubyte, zoomfactor as sint32)
declare function getmousestat(mousestat as mouse_data) as sint32
'/
